/*
Flash Utility v0.2 par Rom1!
Veuillez ne pas supprimer les commentaires incluant des noms d'auteur, merci !

Code d'affichage des images par Manu-R de Gueux ! thank you
Aussi merci  dark_alex pour le code de flash des fichiers (j'ai pas mal modifi)

Si vous utilisez les sources, ce serait sympa de m'inclure dans le read-me.

LICENCE GNU/GPL :
-----------------

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

-----------------

Vive le libre !
*/

//Les librairies
#include <pspsdk.h>
#include <pspkernel.h>
#include <pspctrl.h>
#include <string.h>
#include <pspdebug.h>
#include <psppower.h>

//On inclut les images
#include "menu.c"
#include "gameboot.c"
#include "font.c"
#include "good.c"
#include "non.c"
#include "batterie.c"

// Informations du homebrew
PSP_MODULE_INFO("flashUtility", 0x0800, 1, 0);

PSP_MAIN_THREAD_ATTR(PSP_THREAD_ATTR_VSH);

#define printf pspDebugScreenPrintf


// Le buffer pour copier les fichiers: le nombre d'octets transfrs  la fois.
char buf[16384];

// Fonctions pour le fonctionnement de la touche HOME
int exit_callback(int arg1, int arg2, void *common) 
{ 
	sceKernelExitGame(); 

	return 0; 
} 


void CallbackThread(void *arg)
{
	int cbid;

	cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
	sceKernelRegisterExitCallback(cbid);

	sceKernelSleepThreadCB();
}


int SetupCallbacks(void) 
{ 
	int thid = 0; 

	thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0); 
	if(thid >= 0) 
	{ 
		sceKernelStartThread(thid, 0, 0); 
	} 

	return thid; 
} 




// On convertit l'image .c en 32 bits
// Par Manu-R de gueux !

unsigned int pixel_16to32(unsigned int sourceColor) 
{ 
	unsigned int destColor; 
	int r, g, b; 

	b = (sourceColor&0x7C00)>>10 ; 
	g = (sourceColor&0x03E0)>>5 ; 
	r = (sourceColor&0x001F) ; 

	destColor = ((b&0x1F)<<19)|((g&0x1F)<<11)|((r&0x1F)<<3) ; 

	return destColor; 
} 

// On teste le niveau de chargement de la batterie !



// Ici, c'est la fonction qui affiche une image!
// Dans le cas ci-dessous: le menu.

int afficherMenu()
{
	int x, y; 
	u32* vram = (u32*) (0x40000000 | 0x04000000); 



	// init graphics 
	sceDisplaySetMode(0, 480, 272); 
	sceDisplaySetFrameBuf((void *) vram, 512, 3, 1); 

	// Affichage de l'image
	for (y = 0; y < 272; y++) { 
		for (x = 0; x < 480; x++) { 
			vram[x + y * 512] = pixel_16to32(menu[x + y*480]); 
		} 
	} 

	return 0;
}


// Ici, c'est la fonction qui affiche une image!
// Dans le cas ci-dessous: le menu de flash Gameboot.

int afficherGameboot()
{
	int x, y; 
	u32* vram = (u32*) (0x40000000 | 0x04000000); 



	// init graphics 
	sceDisplaySetMode(0, 480, 272); 
	sceDisplaySetFrameBuf((void *) vram, 512, 3, 1); 

	// Affichage de l'image
	for (y = 0; y < 272; y++) { 
		for (x = 0; x < 480; x++) { 
			vram[x + y * 512] = pixel_16to32(gameboot[x + y*480]); 
		} 
	} 

	return 0;
}


// Ici, c'est la fonction qui affiche une image!
// Dans le cas ci-dessous: l'cran d'erreur.

int afficherErreur()
{
	int x, y; 
	u32* vram = (u32*) (0x40000000 | 0x04000000); 



	// init graphics 
	sceDisplaySetMode(0, 480, 272); 
	sceDisplaySetFrameBuf((void *) vram, 512, 3, 1); 

	// Affichage de l'image
	for (y = 0; y < 272; y++) { 
		for (x = 0; x < 480; x++) { 
			vram[x + y * 512] = pixel_16to32(non[x + y*480]); 
		} 
	} 

	return 0;
}


// Ici, c'est la fonction qui affiche une image!
// Dans le cas ci-dessous: le menu de flash font.

int afficherFont()
{
	int x, y; 
	u32* vram = (u32*) (0x40000000 | 0x04000000); 



	// init graphics 
	sceDisplaySetMode(0, 480, 272); 
	sceDisplaySetFrameBuf((void *) vram, 512, 3, 1); 

	// Affichage de l'image
	for (y = 0; y < 272; y++) { 
		for (x = 0; x < 480; x++) { 
			vram[x + y * 512] = pixel_16to32(font[x + y*480]); 
		} 
	} 

	return 0;
}


// Ici, c'est la fonction qui affiche une image!
// Dans le cas ci-dessous: l'cran de russite.

int afficherGood()
{
	int x, y; 
	u32* vram = (u32*) (0x40000000 | 0x04000000); 



	// init graphics 
	sceDisplaySetMode(0, 480, 272); 
	sceDisplaySetFrameBuf((void *) vram, 512, 3, 1); 

	// Affichage de l'image
	for (y = 0; y < 272; y++) { 
		for (x = 0; x < 480; x++) { 
			vram[x + y * 512] = pixel_16to32(good[x + y*480]); 
		} 
	} 

	return 0;
}


// Ici, c'est la fonction qui affiche une image!
// Dans le cas ci-dessous: l'cran de batterie faible.

int afficherBatterie()
{
	int x, y; 
	u32* vram = (u32*) (0x40000000 | 0x04000000); 



	// init graphics 
	sceDisplaySetMode(0, 480, 272); 
	sceDisplaySetFrameBuf((void *) vram, 512, 3, 1); 

	// Affichage de l'image
	for (y = 0; y < 272; y++) { 
		for (x = 0; x < 480; x++) { 
			vram[x + y * 512] = pixel_16to32(batterie[x + y*480]); 
		} 
	} 

	return 0;
}



// L c'est le code de dark_alex un peu modifi
// Cette fonction copie les fichiers dans le flash !
// A utiliser a vos propres risques.
int copier_fichier(char *input, char *output)
{
	SceUID i = sceIoOpen(input, PSP_O_RDONLY, 0777);    

	// Si le fichier d'entre est inexistant, on renvoit une erreur.
	if (i < 0)
	return -1;

	// Si le fichier est suprieur  512kb, on le refuse pour la simple raison que le flash0 du 271SE-C est restreind (peu de place)
	if (i>512000)
	return -1;

	sceIoRemove(output);

	SceUID o = sceIoOpen(output, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, 0777);

	// Si le fichier du flash est inexistant, on renvoit une erreur.
	if (o < 0)
	return -1;

	int read;

	while ((read = sceIoRead(i, buf, 16384)) > 0)
	{
		sceIoWrite(o, buf, read);
	}

	// Ca c'est fait par moi: ca regarde si le fichier est bien flash.
	if (o<i)
	return -1;

	// On ferme le tout
	sceIoClose(i);
	sceIoClose(o);

	// On renvoit 0 pour dire que tout est OK
	return 0;
}

/*
Etant donn que menuFont et menuGameboot ont besoin de menuPrincipal et menuPrincipal a besoin de mFont et mGameboot, j'ai
t oblig de dclarer plusieurs fois cette fonction (menuPrincipal et menuPrincipal2). Encore bourrain mais je n'ai rien trouv d'autre
*/


int menuPrincipal2()
{

	// On autorise l'criture au flash0.

	sceIoUnassign("flash0:");
	sceIoAssign("flash0:", "lflash0:0,0", "flashfat0:", IOASSIGN_RDWR, NULL, 0);
	

	afficherMenu();





	while(true) // Une boucle infinie
	{
		SceCtrlData pad;
		sceCtrlReadBufferPositive(&pad, 1);

		if (pad.Buttons & PSP_CTRL_START)
		{
			// Touche start enfonce donc retour:
			
			
			
			// On affiche le menu.
			menuPrincipal2();
			
			
			
		}
		
		if (pad.Buttons & PSP_CTRL_UP)
		{
			// Touche haut enfonce donc menu de flash gameboot

			menuGameboot();
			
		}
		
		if (pad.Buttons & PSP_CTRL_DOWN)
		{
			// Touche bas enfonce donc menu de flash font
			menuFont();
			
		}

		if (pad.Buttons & PSP_CTRL_LTRIGGER)
		{

			
			// Touche L enfonce donc flash opening_pluning.rco



			

			if(copier_fichier("ms0:/FlashUtilityFiles/sanslogo.rco", "flash0:/vsh/resource/opening_plugin.rco")<0)
			{
				afficherErreur();

			}
			else
			{
				afficherGood();
				if (pad.Buttons & PSP_CTRL_START)
				{
					// Touche start enfonce donc retour:
					menuPrincipal2();
					
					
				}
			}
			
		}
		
		if (pad.Buttons & PSP_CTRL_RTRIGGER)
		{
			


			if(copier_fichier("ms0:/FlashUtilityFiles/aveclogo.rco", "flash0:/vsh/resource/opening_plugin.rco")<0)
			afficherErreur();

			else
			afficherGood();
			
			
		}

		
	}}







int menuFont()
{
	// On affiche l'image
	afficherFont();
	sceIoUnassign("flash0:");
	sceIoAssign("flash0:", "lflash0:0,0", "flashfat0:", IOASSIGN_RDWR, NULL, 0);
	while(true) // Une boucle infinie
	{
		SceCtrlData pad;
		sceCtrlReadBufferPositive(&pad, 1);


		if (pad.Buttons & PSP_CTRL_SELECT)
		{
			// On retourne au menu...
			menuPrincipal2();
			
		}

		if (pad.Buttons & PSP_CTRL_START)
		{
			// On retourne au menu...
			menuFont();
			
		}


		if (pad.Buttons & PSP_CTRL_CROSS)
		{
			// On flash ltn0.pgf
			if (copier_fichier("ms0:/ltn0.pgf", "flash0:/font/ltn0.pgf") < 0)
			afficherErreur();

			else
			afficherGood();
			
		}
		
		if (pad.Buttons & PSP_CTRL_SQUARE)
		{
			// On flash ltn01.pgf
			if (copier_fichier("ms0:/ltn01.pgf", "flash0:/font/ltn0.pgf") < 0)
			afficherErreur();

			else
			afficherGood();
			
		}  

		if (pad.Buttons & PSP_CTRL_CIRCLE)
		{
			// On flash ltn02.pgf
			if (copier_fichier("ms0:/ltn02.pgf", "flash0:/font/ltn0.pgf") < 0)
			afficherErreur();

			else
			afficherGood();
			
		}

		if (pad.Buttons & PSP_CTRL_TRIANGLE)
		{
			// On flash ltn03.pgf
			if (copier_fichier("ms0:/ltn03.pgf", "flash0:/font/ltn0.pgf") < 0)
			afficherErreur();

			else
			afficherGood();
			
		}


		if (pad.Buttons & PSP_CTRL_LEFT)
		{
			// On flash ltn04.pgf
			if (copier_fichier("ms0:/ltn04.pgf", "flash0:/font/ltn0.pgf") < 0)
			afficherErreur();

			else
			afficherGood();
			
		}

		if (pad.Buttons & PSP_CTRL_RIGHT)
		{
			// On flash ltn05.pgf
			if (copier_fichier("ms0:/ltn05.pgf", "flash0:/font/ltn0.pgf") < 0)
			afficherErreur();

			else
			afficherGood();
			
		}


		
	}


}



int menuGameboot()
{
	// On affiche l'image
	afficherGameboot();
	sceIoUnassign("flash0:");
	sceIoAssign("flash0:", "lflash0:0,0", "flashfat0:", IOASSIGN_RDWR, NULL, 0);
	while(true) // Une boucle infinie
	{
		SceCtrlData pad;
		sceCtrlReadBufferPositive(&pad, 1);


		if (pad.Buttons & PSP_CTRL_SELECT)
		{
			// On retourne au menu...
			menuPrincipal2();
			
			
		}

		if (pad.Buttons & PSP_CTRL_START)
		{
			// On retourne au menu...
			menuGameboot();
			
		}


		if (pad.Buttons & PSP_CTRL_CROSS)
		{
			// On flash gameboot.pmf
			if (copier_fichier("ms0:/gameboot.pmf", "flash0:/vsh/resource/gameboot.pmf") < 0)
			afficherErreur();

			else
			afficherGood();
			
		}
		
		if (pad.Buttons & PSP_CTRL_SQUARE)
		{
			// On flash gameboot1.pmf
			if (copier_fichier("ms0:/gameboot1.pmf", "flash0:/vsh/resource/gameboot.pmf") < 0)
			afficherErreur();

			else
			afficherGood();
			
		}  

		if (pad.Buttons & PSP_CTRL_CIRCLE)
		{
			// On flash gameboot2.pmf
			if (copier_fichier("ms0:/gameboot2.pmf", "flash0:/vsh/resource/gameboot.pmf") < 0)
			afficherErreur();

			else
			afficherGood();
			
		}

		if (pad.Buttons & PSP_CTRL_TRIANGLE)
		{
			// On flash gameboot3.pmf
			if (copier_fichier("ms0:/gameboot3.pmf", "flash0:/vsh/resource/gameboot.pmf") < 0)
			afficherErreur();

			else
			afficherGood();
			
		}


		if (pad.Buttons & PSP_CTRL_LEFT)
		{
			// On flash gameboot4.pmf
			

			if (copier_fichier("ms0:/gameboot4.pmf", "flash0:/vsh/resource/gameboot.pmf") < 0)
			afficherErreur();

			else
			afficherGood();
			
		}

		if (pad.Buttons & PSP_CTRL_RIGHT)
		{

			
			// On flash gameboot5.pmf
			if (copier_fichier("ms0:/gameboot5.pmf", "flash0:/vsh/resource/gameboot.pmf") < 0)
			afficherErreur();

			else
			afficherGood();
			
		}


		
	}


}


/*
Etant donn que menuFont et menuGameboot ont besoin de menuPrincipal et menuPrincipal a besoin de mFont et mGameboot, j'ai
t oblig de dclarer plusieurs fois cette fonction. Encore bourrain mais je n'ai rien trouv d'autre
*/


int menuPrincipal()
{


	pspDebugScreenInit();// On initialise l'cran

	// On autorise l'criture au flash0.
	sceIoAssign("flash0:", "lflash0:0,0", "flashfat0:", IOASSIGN_RDWR, NULL, 0); 
	

	afficherMenu();





	while(true) // Une boucle infinie
	{
		SceCtrlData pad;
		sceCtrlReadBufferPositive(&pad, 1);

		if (pad.Buttons & PSP_CTRL_START)
		{
			// Touche start enfonce donc retour:
			
			
			// On affiche le menu.
			menuPrincipal2();
			
			
			
		}
		
		if (pad.Buttons & PSP_CTRL_UP)
		{
			// Touche haut enfonce donc menu de flash gameboot

			menuGameboot();
			
		}
		
		if (pad.Buttons & PSP_CTRL_DOWN)
		{
			// Touche bas enfonce donc menu de flash font
			menuFont();
			
		}

		if (pad.Buttons & PSP_CTRL_LTRIGGER)
		{

			
			// Touche L enfonce donc flash opening_pluning.rco



			

			if(copier_fichier("ms0:/FlashUtilityFiles/sanslogo.rco", "flash0:/vsh/resource/opening_plugin.rco")<0)
			{
				afficherErreur();

			}
			else
			{
				afficherGood();
				if (pad.Buttons & PSP_CTRL_START)
				{
					// Touche start enfonce donc retour:
					menuPrincipal2();
					
					
				}
			}
			
		}
		
		if (pad.Buttons & PSP_CTRL_RTRIGGER)
		{
			


			if(copier_fichier("ms0:/FlashUtilityFiles/aveclogo.rco", "flash0:/vsh/resource/opening_plugin.rco")<0)
			afficherErreur();

			else
			afficherGood();
			
			
		}

		
	}

}


int testerFirmware()
{
	// On va regarder si le firmware est bien le SE.
	/* Le meilleur moyen que j'ai trouv pour tester la version, c'est regarder si le fichier de
	langue coren (inexistant en 1.5>) est prsent dans le flash0 
	
	Les fonctions de vrif de firm ne fonctionnant pas chez moi, je l'ai fait  la bourrain.*/

	sceIoAssign("flash0:", "lflash0:0,0", "flashfat0:", IOASSIGN_RDWR, NULL, 0);

	if(copier_fichier("flash0:/font/kr0.pgf", "ms0:/FlashUtilityFiles/testfirm.fu")<0)
	{
		// Le firmware est incorrect
		printf("\n Pour lancer ce programme, le firmware 2.71SE doit etre installe\n sur votre PSP. Arret du lancement.");
	}
	else
	{
		// Le firmware est correct donc on lance le prog.
		menuPrincipal();
	}

	return 0;

}


int verifierBatterie()
{

	
	// il faut un minimum de 30% de batterie pour lancer le prog.

	
	if (scePowerGetBatteryLifePercent() < 30)
	{
		pspDebugScreenInit();
		pspDebugScreenClear();
		// La batterie est trop faible.
		// Donc on affiche l'cran de batterie faible.
		afficherBatterie();


		
	}

	else
	{

		pspDebugScreenInit();
		pspDebugScreenClear();
		// La batterie est suffisante, donc on lance l'application.
		testerFirmware();
	}

	return 0;
}







int main(void)
{

	// L c'est le main, peu intressant, a appelle les fonctions.

	SetupCallbacks();
	verifierBatterie();
	
}
